program project1;

{$O-}

uses
  SysUtils;

  procedure RotA(i: integer); inline;
  begin
    asm
             Nop end;
  end;

  procedure RotB(i: integer); inline;
  begin
    asm
             Nop end;
  end;

  procedure RotC(i: integer); inline;
  begin
    asm
             Nop end;
  end;

  procedure RotD(i: integer); inline;
  begin
    asm
             Nop end;
  end;

  procedure RotE(i: integer); inline;
  begin
    asm
             Nop end;
  end;

  procedure RotF(i: integer); inline;
  begin
    asm
             Nop end;
  end;

var
  RotProc: array of procedure(i: integer) = (
    @RotA, @RotB, @RotC, @RotD, @RotE, @RotF,
    @RotA, @RotB, @RotC, @RotD, @RotE, @RotF,
    @RotA, @RotB, @RotC, @RotD, @RotE, @RotF,
    @RotA, @RotB, @RotC, @RotD, @RotE, @RotF,
    @RotA, @RotB, @RotC, @RotD, @RotE, @RotF,
    @RotA, @RotB, @RotC, @RotD, @RotE, @RotF,
    @RotA, @RotB, @RotC, @RotD, @RotE, @RotF,
    @RotA, @RotB, @RotC, @RotD, @RotE, @RotF);

  i: integer;
  t_tmp, t_case, t_proc: TDateTime;

const
  max = 1000000000;

begin
  t_tmp := now;
  for i := 0 to max do begin
    case i mod Length(RotProc) of
      0, 2, 6, 8: begin
        RotA(i);
      end;
      1, 3, 7, 9, 11: begin
        RotB(i);
      end;
      4, 5, 10, 12: begin
        RotC(i);
      end;

      2 + 12, 6 + 12, 8 + 12: begin
        RotD(i);
      end;
      1 + 12, 3 + 12, 7 + 12, 9 + 12, 11 + 12: begin
        RotE(i);
      end;
      4 + 12, 5 + 12, 10 + 12, 12 + 12: begin
        RotF(i);
      end;

      2 + 24, 6 + 24, 8 + 24: begin
        RotD(i);
      end;
      1 + 24, 3 + 24, 7 + 24, 9 + 24, 11 + 24: begin
        RotE(i);
      end;
      4 + 24, 5 + 24, 10 + 24, 24 + 24: begin
        RotF(i);
      end;

      2 + 36, 6 + 36, 8 + 36: begin
        RotD(i);
      end;
      1 + 36, 3 + 36, 7 + 36, 9 + 36, 11 + 36: begin
        RotE(i);
      end;
      4 + 36, 5 + 36, 10 + 36, 36 + 36: begin
        RotF(i);
      end;
    end;
  end;
  t_case := now - t_tmp;

  WriteLn();

  t_tmp := now;
  for i := 0 to max do begin
    RotProc[i mod Length(RotProc)](i);
  end;
  t_proc := now - t_tmp;

  WriteLn('case: ', FormatDateTime('ss:zzz',t_case));
  WriteLn('proc: ', FormatDateTime('ss:zzz',t_proc));
end.
